<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Perform ServiceType
 * @subpackage Services
 * @Author CybernatiC
 * @Version 0.2
 * @Date 17.12.2017
 */
class Perform extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named PerformTransaction
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\PerformTransactionArguments $arguments
     * @return \StructType\PerformTransactionResult|bool
     */
    public function PerformTransaction(\StructType\PerformTransactionArguments $arguments)
    {
        try {
            $this->setResult(self::getSoapClient()->PerformTransaction($arguments));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\PerformTransactionResult
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
