<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelTransactionResult StructType
 * Meta informations extracted from the WSDL
 * - type: tns:CancelTransactionResult
 * @subpackage Structs
 * @Author CybernatiC
 * @Version 0.2
 * @Date 17.12.2017
 */
class CancelTransactionResult extends GenericResult
{
    /**
     * The transactionState
     * @var int
     */
    public $transactionState;
    /**
     * Constructor method for CancelTransactionResult
     * @uses CancelTransactionResult::setTransactionState()
     * @param int $transactionState
     */
    public function __construct($transactionState = null)
    {
        $this
            ->setTransactionState($transactionState);
    }
    /**
     * Get transactionState value
     * @return int|null
     */
    public function getTransactionState()
    {
        return $this->transactionState;
    }
    /**
     * Set transactionState value
     * @param int $transactionState
     * @return \StructType\CancelTransactionResult
     */
    public function setTransactionState($transactionState = null)
    {
        // validation for constraint: int
        if (!is_null($transactionState) && !is_numeric($transactionState)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($transactionState)), __LINE__);
        }
        $this->transactionState = $transactionState;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelTransactionResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
